<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<div class="list-select">

  <label [for]="id + '-select'" class="list-select--label">
    {{"settings.textBlocks.select" | translate}}
  </label>

  <div class="list-select--control">
    <app-select (appValueChange)="setEditedKey($event)"
                [appDisabled]="form.formGroup.disabled || (selectKeys$ | async)?.length == 0"
                [appId]="id + '-select'"
                [appOptions]="selectKeys$ | async | arrayToSelectOptions"
                [appValue]="selectedKey">
    </app-select>
  </div>


  <button (click)="createNewSelectKey(); keyInputElement.focus()"
          [disabled]="form.formGroup.disabled"
          class="openk-button openk-button-icon list-select--button">
    <mat-icon>add</mat-icon>
  </button>


  <label [for]="id + '-name'" class="list-select--label">
    {{"settings.textBlocks.name" | translate}}
  </label>

  <div class="list-select--control">
    <input #keyInputElement
           (input)="changeSelectKey(selectedKey, keyInputElement.value)"
           [disabled]="form.formGroup.disabled || selectedKey == null"
           [id]="id + '-name'"
           [value]="editedKey == null ? '' : editedKey"
           autocomplete="off"
           class="openk-input" type="text">
  </div>


  <button (click)="removeSelectKey(selectedKey); keyInputElement.focus();"
          [disabled]="form.formGroup.disabled"
          class="openk-button openk-button-icon list-select--button">
    <mat-icon>delete_forever</mat-icon>
  </button>

  <ng-container *ngIf="!isEditedKeyValid">
    <div></div>
    <div class="list-select--error">
      <span class="list-select--error--label">
        {{"settings.textBlocks.invalidSelectKey" | translate}}
      </span>
    </div>
    <div></div>
  </ng-container>


  <div class="list-select--options--title">
    {{"settings.textBlocks.entries" | translate}}
  </div>

  <ng-container *ngIf="(form.selects | getFormArray : [selectedKey]) != null">

    <div class="list-select--options">

      <div *ngFor="let control of (form.selects | getFormArray : [selectedKey]).controls; let index = index;"
           class="list--select--options--control">

        <input #selectOptionInput
               (input)="control.patchValue(selectOptionInput.value)"
               [disabled]="form.formGroup.disabled"
               [value]="control.value"
               appAutoFocusAfterInit
               autocomplete="off"
               class="openk-input list--select--options--control--input"
               type="text">

        <div class="list--select--options--control--button">
          <button (click)="removeSelectEntry(selectedKey, index)"
                  [disabled]="form.formGroup.disabled" class="openk-button openk-button-icon">
            <mat-icon>delete_forever</mat-icon>
          </button>
        </div>

      </div>

    </div>

    <div class="list--select--options--control list-select--options--control--add">
      <button (click)="addSelectEntry(selectedKey)"
              [disabled]="form.formGroup.disabled"
              class="openk-button openk-button-icon list-select--button">
        <mat-icon>add</mat-icon>
      </button>
    </div>

  </ng-container>

</div>
